with Interfaces; use Interfaces;

package body CORBA_Repository_Root_SequenceDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 6, 18);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (13, 24, 26, 1);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (6, 25, 19, 18);

   G : constant array (0 .. 26) of Unsigned_8 :=
     (7, 0, 0, 0, 10, 0, 0, 0, 1, 11, 4, 4, 11, 0, 0, 0, 0, 9, 12, 3, 0, 0,
      0, 0, 0, 1, 11);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 27;
         F2 := (F2 + Natural (T2 (K)) * J) mod 27;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 13;
   end Hash;

end CORBA_Repository_Root_SequenceDef_Hash;
